// playCmajor.ck
// expand on Homework 3-4
Hid hi;
HidMsg msg;

// which keyboard
0 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

// open keyboard (get device number from command line)
if( !hi.openKeyboard( device ) ) me.exit();
<<< "keyboard '" + hi.name() + "' ready", "" >>>;

65  => int ascii_a;
66  => int ascii_b;
67  => int ascii_c;
68  => int ascii_d;
69  => int ascii_e;
70  => int ascii_f;
71  => int ascii_g;

// Shift key code is different on windows 
// http://www.win.tue.nl/~aeb/linux/kbd/scancodes-1.html gives
// 42 => int which_ShiftLeft;  // win
// 54 => int which_ShiftRight; // win
// 225 => int which_Shift;     // mac

0 => int shiftDown;

MidiOut mout;
MidiMsg mmsg;

mout.open( 0 ) => int amIOpen;
if( !amIOpen )
    me.exit();

// Major scale starting on zero, 12 half steps in an octave
// whole step and half step pattern of the major scale
// 0 2 4 5 7 9 11 12
fun void playIt(int zeroBasedNote, int vel, int scaleStart, int patchNum) 
{
	if ( vel == 0 )
		<<< " NOF\t", zeroBasedNote+scaleStart, "\tvel\t", vel, "\tpatch\t", patchNum >>>;
	else
		<<< " NOF\t", zeroBasedNote+scaleStart, "\tvel\t", vel, "\tpatch\t", patchNum >>>;

	// play midi note
	patchChange(patchNum);
	0x90 => mmsg.data1;
	scaleStart + zeroBasedNote => mmsg.data2;
	vel => mmsg.data3;
	mout.send(mmsg);
}

function void patchChange(int patchNum )
{
    0xC0 => mmsg.data1;
    patchNum => mmsg.data2;
    0 => mmsg.data3;
    mout.send( mmsg );
}

// change these as desired
0 => int patchNum;
60 => int scaleStart;

// infinite event loop
while( true )
{
    // wait on event
    hi => now;
    
    // get one or more messages
    while( hi.recv( msg ) )
    {
        // check for action type
        if ( msg.isButtonDown() )
        {
            if ( msg.which == 225)
            {
                1 => shiftDown;
            }
            if (msg.ascii == ascii_c)
            {
            	if ( shiftDown )
                    playIt( 12,  100, scaleStart, patchNum );
                else
                    playIt( 0, 100, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_d)
            {
                playIt( 2, 100, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_e)
            {
                playIt( 4, 100, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_f)
            {
                playIt( 5, 100, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_g)
            {
                playIt( 7, 100, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_a)
            {
                playIt( 9, 100, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_b)
            {
                playIt( 11, 100, scaleStart, patchNum );
            }
        }
        else if ( msg.isButtonUp() )
        {
            if ( msg.which == 225)
            {
                0 => shiftDown;
            }
/*
            if (msg.ascii == ascii_c)
            {
                // no harm in turning both off
                playIt( 12, 0, scaleStart, patchNum );
                playIt( 0, 0, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_d)
            {
                playIt( 2, 0, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_e)
            {
                playIt( 4, 0, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_f)
            {
                playIt( 5, 0, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_g)
            {
                playIt( 7, 0, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_a)
            {
                playIt( 9, 0, scaleStart, patchNum );
            }
            else if (msg.ascii == ascii_b)
            {
                playIt( 11, 0, scaleStart, patchNum );
            } 
    
            } 
*/    
        }
    }
}
